diff --git a/test/integration/run_review_test.rb b/test/integration/run_review_test.rb
index 80ef0996..7f62ee34 100644
--- a/test/integration/run_review_test.rb
+++ b/test/integration/run_review_test.rb
@@ -14,6 +14,66 @@ require "hive/stages/review"
 class RunReviewTest < Minitest::Test
   include HiveTestHelper
 
+  class ReviewFixTmuxRunner
+    attr_reader :name, :killed, :submitted_prompts
+
+    def initialize(name:, worktree:)
+      @name = name
+      @worktree = worktree
+      @alive = false
+      @turn_started = false
+      @turn_captures = 0
+      @killed = false
+      @submitted_prompts = []
+    end
+
+    def start_detached(command:)
+      @alive = true
+    end
+
+    def session_exists?
+      @alive
+    end
+
+    def pane_pid
+      Process.pid
+    end
+
+    def send_prompt(prompt)
+      return if prompt == "/quit"
+
+      @submitted_prompts << prompt
+      @turn_started = true
+      File.write(File.join(@worktree, "tmux-fix.txt"), "fixed through launcher\n")
+      raise "git add failed" unless Kernel.system("git", "-C", @worktree, "add", "tmux-fix.txt")
+      unless Kernel.system("git", "-C", @worktree, "commit", "-m", "fix through tmux launcher", "--quiet")
+        raise "git commit failed"
+      end
+    end
+
+    def capture_pane_tail(bytes:)
+      return idle_pane unless @turn_started
+
+      @turn_captures += 1
+      @turn_captures == 1 ? "Claude Code\nApplying review fixes...\n" : idle_pane
+    end
+
+    def send_keys(*)
+      nil
+    end
+
+    def kill_session
+      @killed = true
+      @alive = false
+    end
+
+    private
+
+    def idle_pane
+      "Claude Code v2.1.179\n────────\n❯\n"
+    end
+  end
+
   def setup
     @prev_bin = ENV["HIVE_CLAUDE_BIN"]
     @driver_dir = Dir.mktmpdir("review-driver")
@@ -124,6 +184,57 @@ class RunReviewTest < Minitest::Test
     }
   end
 
+  def clean_completion_timeout(folder)
+    {
+      status: :timeout,
+      error_message: "claude stop hook did not signal completion",
+      completion_evidence: {
+        reason: :busy_to_idle,
+        expected_signal_paths: {
+          sentinel: File.join(folder, ".done"),
+          result: File.join(folder, "result.json")
+        },
+        normal_completion: true,
+        launch_mode: :tmux,
+        work_started: true,
+        pane_idle: true,
+        session_alive: true,
+        tmux_readable: true,
+        provider_limit: false,
+        sentinel_present: false,
+        result_present: false,
+        session_error: nil,
+        process_state: :alive,
+        pid: 12_345,
+        session_name: "hive-review-fix",
+        exit_code: nil
+      }
+    }
+  end
+
+  def prepare_waiting_fix(folder, reviewer_body:, escalations_body: nil)
+    reviews = File.join(folder, "reviews")
+    FileUtils.mkdir_p(reviews)
+    reviewer = File.join(reviews, "stub-reviewer-01.md")
+    File.write(reviewer, reviewer_body)
+    File.write(
+      File.join(reviews, "escalations-01.md"),
+      escalations_body || "# Escalations for pass 01\n\n_All clean._\n"
+    )
+    Hive::Markers.set(File.join(folder, "task.md"), :review_waiting, pass: 1, escalations: 0)
+    reviewer
+  end
+
+  def completion_fallback_events(folder)
+    path = File.join(folder, "events.jsonl")
+    return [] unless File.exist?(path)
+
+    File.readlines(path).filter_map do |line|
+      event = JSON.parse(line)
+      event if event["event_type"] == "claude_completion_fallback"
+    end
+  end
+
 
   # --- pre-flight terminal markers short-circuit -----------------------
 
@@ -2343,6 +2454,337 @@ class RunReviewTest < Minitest::Test
     end
   end
 
+  def test_tmux_launcher_missing_stop_fix_commit_completes_and_cleans_up
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir, cfg_overrides: {
+          "claude" => { "mode" => "tmux" }
+        })
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a fix\n")
+        runner = ReviewFixTmuxRunner.new(name: "review-fix-integration", worktree: worktree)
+
+        with_env(
+          "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.001",
+          "HIVE_CLAUDE_TMUX_STOP_SIGNAL_GRACE_SEC" => "0.005",
+          "HIVE_CLAUDE_TMUX_SHUTDOWN_GRACE_SEC" => "0"
+        ) do
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :build_runner, ->(**_kwargs) { runner }) do
+            with_replaced_singleton_method(Hive::ClaudeLauncher, :preflight!, ->(_profile, _runner) { }) do
+              with_replaced_singleton_method(Hive::ClaudeLauncher, :sweep_orphan_processes, ->(_task) { }) do
+                out, err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+                assert_equal 0, status, "stdout=#{out.inspect} stderr=#{err.inspect}"
+              end
+            end
+          end
+        end
+
+        assert_equal :review_complete, Hive::Markers.current(File.join(folder, "task.md")).name
+        events = completion_fallback_events(folder)
+        assert_equal 1, events.size
+        message = events.first.fetch("message")
+        assert_includes message, "level=warn"
+        assert_includes message, "phase=fix"
+        assert_includes message, "pass=1"
+        assert_includes message, "commit_transition"
+        assert_includes message, ".done"
+        assert_includes message, "result.json"
+        assert_equal 1, runner.submitted_prompts.size
+        assert runner.killed
+        refute_path_exists Hive::ClaudeLauncher.done_path(Struct.new(:folder).new(folder))
+        refute_path_exists Hive::ClaudeLauncher.result_path(Struct.new(:folder).new(folder))
+        refute_path_exists File.join(folder, ".claude", "settings.json")
+        refute_path_exists File.join(worktree, ".claude", "settings.json")
+      end
+    end
+  end
+
+  def test_headless_fix_failure_never_enters_tmux_completion_fallback
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a fix\n")
+        File.write(@driver_bin, <<~SH)
+          #!/usr/bin/env bash
+          if [[ "${1:-}" == "--version" ]]; then
+            echo "2.1.118 (Claude Code)"
+            exit 0
+          fi
+          exit 9
+        SH
+
+        _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+
+        assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix", marker.attrs["phase"]
+        assert_equal "fix_failed", marker.attrs["reason"]
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_missing_stop_with_dirty_fix_uses_existing_auto_commit_path
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        reviewer = prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a fix\n")
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          FileUtils.mkdir_p(File.join(worktree, "test"))
+          File.write(File.join(worktree, "test", "dirty-fix.txt"), "fixed\n")
+          fallback_result
+        }) do
+          out, err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal 0, status, "stdout=#{out.inspect} stderr=#{err.inspect}"
+        end
+
+        assert_equal "", `git -C #{worktree} status --porcelain`
+        assert_equal "fix(review): apply pass 01 findings",
+                     `git -C #{worktree} log -1 --pretty=%s`.strip
+        message = completion_fallback_events(folder).first.fetch("message")
+        assert_includes message, "evidence_basis=dirty_worktree"
+        assert_equal :review_complete, Hive::Markers.current(File.join(folder, "task.md")).name
+        assert File.exist?(reviewer)
+      end
+    end
+  end
+
+  def test_missing_stop_with_explicit_whole_pass_no_change_completes_without_commit
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        prepare_waiting_fix(
+          folder,
+          reviewer_body: "## High\n- [x] RESOLVED/NO-FIX: existing code is already correct\n",
+          escalations_body: <<~MD
+            # Escalations for pass 01
+
+            ## Round 1
+
+            ### Q1. Is a code change required?
+            Source: stub-reviewer-01.md
+            Finding: existing code is already correct
+            ### A1.
+            No code change is required.
+          MD
+        )
+        before = `git -C #{worktree} rev-parse HEAD`.strip
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          fallback_result
+        }) do
+          out, err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal 0, status, "stdout=#{out.inspect} stderr=#{err.inspect}"
+        end
+
+        assert_equal before, `git -C #{worktree} rev-parse HEAD`.strip
+        assert_equal "", `git -C #{worktree} status --porcelain`
+        message = completion_fallback_events(folder).first.fetch("message")
+        assert_includes message, "evidence_basis=whole_pass_no_change"
+        assert_equal :review_complete, Hive::Markers.current(File.join(folder, "task.md")).name
+      end
+    end
+  end
+
+  def test_missing_stop_cannot_use_rewritten_reviewer_artifact_as_no_change_proof
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        reviewer = prepare_waiting_fix(
+          folder,
+          reviewer_body: "## High\n- [x] AUTO-FIX: existing code is already correct\n"
+        )
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          File.write(
+            reviewer,
+            "## High\n- [x] RESOLVED/NO-FIX: existing code is already correct\n"
+          )
+          fallback_result
+        }) do
+          _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_tampered", marker.attrs["reason"]
+        assert_includes marker.attrs.fetch("files"), "reviews/stub-reviewer-01.md"
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_missing_stop_cannot_use_reviewer_artifact_created_during_fix
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        prepare_waiting_fix(
+          folder,
+          reviewer_body: "## High\n- [x] AUTO-FIX: existing code is already correct\n"
+        )
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          File.write(
+            File.join(folder, "reviews", "fabricated-reviewer-01.md"),
+            "## High\n- [x] RESOLVED/NO-FIX: existing code is already correct\n"
+          )
+          fallback_result
+        }) do
+          _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_tampered", marker.attrs["reason"]
+        assert_includes marker.attrs.fetch("files"), "reviews/fabricated-reviewer-01.md"
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_missing_stop_cannot_treat_backward_head_move_as_fix_commit
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        File.write(File.join(worktree, "second.txt"), "second\n")
+        run!("git", "-C", worktree, "add", "second.txt")
+        run!("git", "-C", worktree, "commit", "-m", "second", "--quiet")
+        prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a fix\n")
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          unless Kernel.system("git", "-C", worktree, "reset", "--hard", "--quiet", "HEAD^")
+            raise "git reset failed"
+          end
+          fallback_result
+        }) do
+          out, err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal Hive::ExitCodes::TASK_IN_ERROR, status,
+                       "stdout=#{out.inspect} stderr=#{err.inspect}"
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_failed", marker.attrs["reason"]
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_missing_stop_with_mixed_no_change_dispositions_remains_fix_failed
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        prepare_waiting_fix(
+          folder,
+          reviewer_body:
+            "## High\n" \
+            "- [x] AUTO-FIX: first fix\n" \
+            "- [x] AUTO-FIX: second fix\n" \
+            "- [x] RESOLVED/NO-FIX: unrelated finding\n"
+        )
+        fallback_result = clean_completion_timeout(folder)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          fallback_result
+        }) do
+          _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+          assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_failed", marker.attrs["reason"]
+        assert_equal "claude stop hook did not signal completion", marker.attrs["message"]
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_missing_stop_fallback_remains_fix_failed_when_audit_cannot_persist
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a fix\n")
+        fallback_result = clean_completion_timeout(folder)
+        original_emit = Hive::Events.method(:emit)
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          File.write(File.join(worktree, "fix.txt"), "fixed\n")
+          raise "git add failed" unless Kernel.system("git", "-C", worktree, "add", "fix.txt")
+          unless Kernel.system("git", "-C", worktree, "commit", "-m", "fix test", "--quiet")
+            raise "git commit failed"
+          end
+          fallback_result
+        }) do
+          with_replaced_singleton_method(Hive::Events, :emit, lambda { |**kwargs|
+            if kwargs[:event_type] == :claude_completion_fallback
+              nil
+            else
+              original_emit.call(**kwargs)
+            end
+          }) do
+            _out, _err, status = with_captured_exit { Hive::Commands::Run.new(folder).call }
+            assert_equal Hive::ExitCodes::TASK_IN_ERROR, status
+          end
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_error, marker.name
+        assert_equal "fix_failed", marker.attrs["reason"]
+        assert_empty completion_fallback_events(folder)
+      end
+    end
+  end
+
+  def test_accepted_completion_fallback_still_stops_at_fix_guardrail
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        folder = setup_review_task(dir)
+        worktree = YAML.safe_load(File.read(File.join(folder, "worktree.yml")))["path"]
+        prepare_waiting_fix(folder, reviewer_body: "## High\n- [x] apply a risky fix\n")
+        fallback_result = clean_completion_timeout(folder)
+        match = Hive::Stages::Review::FixGuardrail::Match.new(
+          pattern_name: "test-risk",
+          file: "test/risky.txt",
+          line: 1,
+          snippet: "risky",
+          severity: :high
+        )
+
+        with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, lambda { |_task, _cfg, _ctx, accepted:|
+          FileUtils.mkdir_p(File.join(worktree, "test"))
+          File.write(File.join(worktree, "test", "risky.txt"), "risky\n")
+          fallback_result
+        }) do
+          with_replaced_singleton_method(Hive::Stages::Review::FixGuardrail, :run!, lambda { |**_kwargs|
+            Hive::Stages::Review::FixGuardrail::Result.new(status: :tripped, matches: [ match ])
+          }) do
+            capture_io { Hive::Commands::Run.new(folder).call }
+          end
+        end
+
+        marker = Hive::Markers.current(File.join(folder, "task.md"))
+        assert_equal :review_waiting, marker.name
+        assert_equal "fix_guardrail", marker.attrs["reason"]
+        assert_equal 1, completion_fallback_events(folder).size
+        refute File.exist?(File.join(folder, "reviews", "fix-success-01.md"))
+      end
+    end
+  end
+
   def test_fix_agent_limit_text_yields_limits_reached_marker
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
diff --git a/test/unit/babysitter/events_test.rb b/test/unit/babysitter/events_test.rb
index 964bae5f..47fbe0c7 100644
--- a/test/unit/babysitter/events_test.rb
+++ b/test/unit/babysitter/events_test.rb
@@ -44,6 +44,29 @@ class BabysitterEventsTest < Minitest::Test
     end
   end
 
+  def test_emit_raises_when_the_append_is_short
+    with_tmp_dir do |dir|
+      project = project_entry(dir)
+      short_writer = Object.new
+      short_writer.define_singleton_method(:syswrite) { |line| line.bytesize - 1 }
+      open_file = lambda do |*_args, **_kwargs, &block|
+        block.call(short_writer)
+      end
+
+      error = assert_raises(IOError) do
+        with_replaced_singleton_method(File, :open, open_file) do
+          Hive::Babysitter::Events.emit(
+            project: project,
+            action: "rebase",
+            outcome: "success"
+          )
+        end
+      end
+
+      assert_match(/short append/, error.message)
+    end
+  end
+
   def test_emit_raises_on_unknown_action_and_outcome
     with_tmp_dir do |dir|
       project = project_entry(dir)
diff --git a/test/unit/claude_completion_fallback_test.rb b/test/unit/claude_completion_fallback_test.rb
new file mode 100644
index 00000000..4006a483
--- /dev/null
+++ b/test/unit/claude_completion_fallback_test.rb
@@ -0,0 +1,121 @@
+require "test_helper"
+require "hive/claude_completion_fallback"
+
+class ClaudeCompletionFallbackTest < Minitest::Test
+  REQUIRED_FACTS = {
+    artifacts_present: true,
+    artifacts_parseable: true,
+    commit_or_no_change: true,
+    no_unresolved_escalation: true,
+    worktree_readable: true,
+    no_missing_output: true
+  }.freeze
+
+  def test_complete_evidence_and_facts_suppress_the_missing_signal
+    result = Hive::ClaudeCompletionFallback.evaluate(
+      evidence: complete_evidence,
+      facts: REQUIRED_FACTS
+    )
+
+    assert_equal true, result.suppress
+    assert_empty result.missing_reasons
+  end
+
+  def test_each_required_evidence_field_fails_closed
+    {
+      normal_completion: false,
+      work_started: false,
+      pane_idle: false,
+      session_alive: nil,
+      tmux_readable: false,
+      provider_limit: true,
+      sentinel_present: true,
+      result_present: true,
+      session_error: "pane failed",
+      process_state: :dead,
+      launch_mode: :headless,
+      exit_code: 1
+    }.each do |field, invalid|
+      evidence = complete_evidence.merge(field => invalid)
+      result = Hive::ClaudeCompletionFallback.evaluate(
+        evidence: evidence,
+        facts: REQUIRED_FACTS
+      )
+
+      assert_equal false, result.suppress, "#{field}=#{invalid.inspect} must block"
+      assert_includes result.missing_reasons, field
+    end
+  end
+
+  def test_each_required_phase_fact_fails_closed
+    REQUIRED_FACTS.each_key do |fact|
+      result = Hive::ClaudeCompletionFallback.evaluate(
+        evidence: complete_evidence,
+        facts: REQUIRED_FACTS.merge(fact => false)
+      )
+
+      assert_equal false, result.suppress
+      assert_includes result.missing_reasons, :"phase_fact_#{fact}"
+    end
+  end
+
+  def test_missing_evidence_and_missing_facts_fail_closed
+    absent = Hive::ClaudeCompletionFallback.evaluate(evidence: nil, facts: {})
+    assert_equal false, absent.suppress
+    assert_includes absent.missing_reasons, :completion_evidence
+
+    Hive::ClaudeCompletionFallback::REQUIRED_PHASE_FACTS.each do |fact|
+      assert_includes absent.missing_reasons, :"phase_fact_#{fact}"
+    end
+  end
+
+  def test_string_and_symbol_keys_normalize_without_truthy_string_coercion
+    string_evidence = complete_evidence.transform_keys(&:to_s)
+    string_facts = REQUIRED_FACTS.transform_keys(&:to_s)
+
+    accepted = Hive::ClaudeCompletionFallback.evaluate(
+      evidence: string_evidence,
+      facts: string_facts
+    )
+    assert_equal true, accepted.suppress
+
+    string_evidence["pane_idle"] = "true"
+    rejected = Hive::ClaudeCompletionFallback.evaluate(
+      evidence: string_evidence,
+      facts: string_facts
+    )
+    assert_equal false, rejected.suppress
+    assert_includes rejected.missing_reasons, :pane_idle
+  end
+
+  def test_zero_real_exit_code_is_allowed_but_unknown_tmux_exit_code_is_expected
+    assert Hive::ClaudeCompletionFallback.evaluate(
+      evidence: complete_evidence.merge(exit_code: 0),
+      facts: REQUIRED_FACTS
+    ).suppress
+
+    assert Hive::ClaudeCompletionFallback.evaluate(
+      evidence: complete_evidence.merge(exit_code: nil),
+      facts: REQUIRED_FACTS
+    ).suppress
+  end
+
+  private
+
+  def complete_evidence
+    {
+      normal_completion: true,
+      launch_mode: :tmux,
+      work_started: true,
+      pane_idle: true,
+      session_alive: true,
+      tmux_readable: true,
+      provider_limit: false,
+      sentinel_present: false,
+      result_present: false,
+      session_error: nil,
+      process_state: :alive,
+      exit_code: nil
+    }
+  end
+end
